package com.your.company.domain.UDEPattern.code;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

import com.ibm.broker.config.appdev.patterns.ui.PatternPropertyEditorSite;

public class MyComposite extends Composite {

	private Table table;
	private TableColumn tblclmnNewColumn;
	private TableColumn tblclmnNewColumn_1;
	private PatternPropertyEditorSite site;
	
	private Connection con=null;
	private CallableStatement statement=null;
	private ResultSet rs=null;
	private int i;
	private Combo combo;
	
	//this Constructor is called by MyEditor when it starts. 
	public MyComposite(Composite parent, int style,final PatternPropertyEditorSite site) {
		super(parent, style);
		this.site = site;

	
		//This is the table that will contain the Queue Manager / Queue Names.
		table = new Table(this, SWT.BORDER | SWT.FULL_SELECTION | SWT.SINGLE);
		table.setBounds(10, 37, 343, 220);
		table.setHeaderVisible(true);
		table.setLinesVisible(true);
		
		
		//This listener will invoke the widgetSelected method when a selection is made. 
		table.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
									//When a selection is made in the table, we inform the Pattern Instance Editor to place a dirty mark on the pattern.
									site.valueChanged();}
		});
		
		//Add 2 columns to the table.
		tblclmnNewColumn = new TableColumn(table, SWT.SINGLE,0);
		tblclmnNewColumn.setWidth(200);
		tblclmnNewColumn.setText("Queue Manager");
		
		tblclmnNewColumn_1 = new TableColumn(table,SWT.SINGLE,1);
		tblclmnNewColumn_1.setWidth(200);
		tblclmnNewColumn_1.setText("Queue");
		
	
		
		try {
			  // Load the DB2(R) Universal JDBC Driver with DriverManager.
			  Class.forName("com.ibm.db2.jcc.DB2Driver");
			  con = DriverManager.getConnection("jdbc:db2://localhost:50000/MQ:user=WMBADMIN;password=passw0rd;");
			  
			} catch (ClassNotFoundException e) {
			     e.printStackTrace();
			} catch (SQLException e) {
				e.printStackTrace();
			} 
			
			
		//Create the environment combo box.
		combo = new Combo(this, SWT.READ_ONLY);
		combo.setBounds(10, 10, 343, 21);
		
		

			
		//Add a listener that will invoke the widgetSelected method when a selection is made in the combo box.
		combo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				try {
					//Clean the table.
					table.deselectAll();
					table.removeAll();
					
					//Inform the Pattern Instance Editor that a change was made so that a dirty mark is placed.
					site.valueChanged();
					
					//Retrieve rows from the DB2 table, filtering by environment.
					statement = con.prepareCall("SELECT QM,QUEUE FROM QUEUES WHERE ENVIRONMENT = '" + combo.getText()+"'");
					rs = statement.executeQuery();
					if(rs!=null){
						i =0;
						//Fill the table with the rows retrieved from the DB2 table.
						while(rs.next()){
							TableItem tableItem = new TableItem(table, SWT.NONE,i++);
							tableItem.setText(0,rs.getString("QM"));
							tableItem.setText(1,rs.getString("QUEUE"));
						}
						rs.close();
					}
				} catch (SQLException sqle) {
							sqle.printStackTrace();
				}
			}
		});
		
		


		
			try {
				//Retrieve the environment values from the DB2 table.
				statement = con.prepareCall("SELECT UNIQUE ENVIRONMENT FROM QUEUES");
				rs = statement.executeQuery();
				if(rs!=null){
					while(rs.next()){
						//Add the retrieved values to the combo.
						combo.add(rs.getString("ENVIRONMENT"));
					}
					rs.close();
				}
				//Ensure no item is selected. 
				combo.deselectAll();

			} catch (SQLException e1) {
				e1.printStackTrace();
			}
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	
	public String getValue() {
	//This method is invoked by MyEditor to retrieve the selected value.
		
		TableItem[] tis = table.getSelection();		
		if (tis.length!=0){
			//Return the Queue Manager and Queue Name concatanated in a string, separated by a comma. 
			return (tis[0].getText(0) + "," + tis[0].getText(1));
		}else{
			//If nothing was selected, return null.
			return null;
		}
	}
	
	public void setEnabled(boolean enabled) {
		//When the User-Defined Editor is enabled/disabled, enable/disable the combo and the table.		
		combo.setEnabled(enabled);
		table.setEnabled(enabled);
	}
}
