package com.your.company.domain.UDEPattern.code;

import com.ibm.broker.config.appdev.MessageFlow;
import com.ibm.broker.config.appdev.nodes.MQOutputNode;
import com.ibm.broker.config.appdev.patterns.GeneratePatternInstanceTransform;
import com.ibm.broker.config.appdev.patterns.PatternInstanceManager;

public class MyJava implements GeneratePatternInstanceTransform {

	@Override
	public void onGeneratePatternInstance(PatternInstanceManager patternInstanceManager) {
		
		//Get the RoutingFlow.msgflow message flow
		MessageFlow mf1 = patternInstanceManager.getMessageFlow("UDEApp_broker", "UDE_Flow.msgflow");
		
		//Get the Route Node object
		MQOutputNode mqout = (MQOutputNode) mf1.getNodeByName("MQ Output");
		
		//Get the Queue Manager and Queue Name values from the Parameter.
		String[] values = patternInstanceManager.getParameterValue("UDEParameter").split(",");
		String QM = values[0].trim();
		String Q = values[1].trim();
		
		//Set the MQOutput node properties.
		mqout.setQueueManagerName(QM);
		mqout.setQueueName(Q);
		
	}

}
